﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Management;

namespace SystemInfo
{
    public partial class frmserial : Form
    {
        public frmserial()
        {
            InitializeComponent();
        }

        FiveSevenNine MyHDDGen;

        private void button1_Click(object sender, EventArgs e)
        {
          //  FiveSevenNine MyHDDGen = new FiveSevenNine();
            if (rdHDD.Checked)
            {
                MyHDDGen.GenerateFromHDD();
            }
            else if (rdMAC.Checked)
            {
                MyHDDGen.GenerateFromMAC();
            }
            else
            {
                if (chkHex.Checked)
                {
                    MyHDDGen.GenerateForNumber((int)Int64.Parse(txtNumber.Text, System.Globalization.NumberStyles.HexNumber));
                }
                else 
                {
                    MyHDDGen.GenerateForNumber((int)Int64.Parse(txtNumber.Text));
                }
            }
            
            this.lblFive.Text = MyHDDGen.Five.ToString();
            this.lblSeven.Text = MyHDDGen.Seven.ToString();
            this.lblNine.Text= MyHDDGen.Nine.ToString();
            
        }

        private void btnGenerate_Click(object sender, EventArgs e)
        {
            SerialNumber MySerial = new SerialNumber();
            Random Randomizer = new Random(99999);
            txtSerial.Text = MySerial.GenerateSerial(Randomizer.Next(999,99999), MyHDDGen.Five, MyHDDGen.Seven, MyHDDGen.Nine);
        }

        private void frmserial_Load(object sender, EventArgs e)
        {
            MyHDDGen = new FiveSevenNine();
        }

        private void btnCheck_Click(object sender, EventArgs e)
        {
            SerialNumber MySerial = new SerialNumber();
            if (MySerial.CheckSerial(txtSerial.Text, MyHDDGen.Five, MyHDDGen.Seven, MyHDDGen.Nine))
            {
                lblChkResult.Text = "Correct";
            }
            else
            {
                lblChkResult.Text = "Incorrect";
            }
            
        }
    }

    public partial class SerialNumber
    {
        public string GenerateSerial(int seed, int five, int seven, int nine)
        {
            if (five <= 2 || seven <= 2 || nine <= 2)
            {
                return "0000-0000-0000";
            }
            int Five, Seven, Nine, Scaler;
            Random Ranomizer = new Random();
            bool Done = false;
            Scaler = Ranomizer.Next(2, 20);
            Five = seed * Scaler + 5;
            sleep(100);
            Scaler = Ranomizer.Next(2, 20);
            Seven = seed * Scaler + 7;
            sleep(100);
            Scaler = Ranomizer.Next(2, 20);
            Nine = seed * Scaler + 9;

            while (!Done)
            {
                Done = true;
                if (Five % five != 0)
                {
                    Five--;
                    Done = false;
                }
                if (Seven % seven != 0)
                {
                    Seven--;
                    Done = false;
                }
                if (Nine % nine != 0)
                {
                    Nine--;
                    Done = false;
                }
            }//while
            return Five.ToString() + "-" + Seven.ToString() + "-" + Nine.ToString();
        }

        public bool CheckSerial(string Serial, int Five, int Seven, int Nine)
        {
            if (Five <= 2 || Seven <= 2 || Nine <= 2)
            {
                return false;
            }
            int five = int.Parse(Serial.Split('-')[0]);
            int seven = int.Parse(Serial.Split('-')[1]);
            int nine = int.Parse(Serial.Split('-')[2]);
            if (five <= 2 || seven <= 2 || nine <= 2)
            {
                return false;
            }
            if ((five % Five == 0) && (seven % Seven == 0) && (nine % Nine == 0))
            {
                return true;
            }
            return false;
        }
        private void sleep(int Time)
        {
            System.Threading.Thread.Sleep(Time);
        }
    }//class serial number


    public partial class FiveSevenNine
    {
        int FIVE;
        int SEVEN;
        int NINE;

        public int Five
        {
            get { return FIVE; }
        }
        public int Seven
        {
            get { return SEVEN; }
        }
        public int Nine
        {
            get { return NINE; }
        }
        public void GenerateFromHDD()
        {
            string drive = "C";
            int HDDNum;
            ManagementObject disk = new ManagementObject("win32_logicaldisk.deviceid=\"" + drive + ":\"");
            //bind our management object
            disk.Get();
            //return the serial number
            HDDNum = int.Parse(disk["VolumeSerialNumber"].ToString(), System.Globalization.NumberStyles.HexNumber);
            GenerateFromDevID(HDDNum);
        }


        public void GenerateFromMAC()
        {
            Int64 MACAdd = Int64.Parse(GetMACAddress(), System.Globalization.NumberStyles.HexNumber);
            GenerateFromDevID((int)(MACAdd & 0xffffffff));
        }

        public void GenerateForNumber(int Number)
        {
            GenerateFromDevID(Number);
        }
        void GenerateFromDevID(int MACorHDD)
        {
            FIVE = (int)(MACorHDD & 0xff);
            SEVEN = (int)(MACorHDD & 0xff00) >> 8;
            NINE = (int)(MACorHDD & 0xff0000) >> 16;
        }

        string GetMACAddress()
        {
            ManagementClass mc = new ManagementClass("Win32_NetworkAdapterConfiguration");
            ManagementObjectCollection moc = mc.GetInstances();
            string MACAddress = String.Empty;
            foreach (ManagementObject mo in moc)
            {
                if (MACAddress == String.Empty) // only return MAC Address from first card
                {
                    if ((bool)mo["IPEnabled"] == true) MACAddress = mo["MacAddress"].ToString();
                }
                mo.Dispose();
            }

            MACAddress = MACAddress.Replace(":", "");
            return MACAddress;
        } 


    }
}
